<template>
  <div class="h-14 w-full z-[-1]"></div>
  <!-- TODO: Refactor using loop instead of static HTML for footer menu item -->
  <div
    v-if="auth || !displayAuthButtons"
    class="fixed bottom-0 left-0 z-30 flex justify-center w-full px-1 !py-0 fc-text bg-background3 shadow-top footer-menu h-[56px] main-footer"
  >
    <nuxt-link
      v-if="!isIndex"
      :id="ID.TAB_TYPE_MOBILE_BOTTOM_BAR.HOME"
      to="/"
      class="flex-1 mx-auto text-center"
    >
      <IconHome class="w-4 h-4 pointer-events-none" />
      <div
        class="footer-menu-item-title home-tab pointer-events-none"
        :class="[
          $route.name === 'home' ? 'text-[color:var(--selected)]' : 'fc-text4',
          isMain ? 'h-[14px] flex justify-center items-center' : '',
        ]"
      >
        {{ $t("home") }}
      </div>
    </nuxt-link>
    <nuxt-link
      v-if="isIndex && isAllowPromotionTab"
      :id="ID.TAB_TYPE_MOBILE_BOTTOM_BAR.PROMOTION"
      class="flex-1 mx-auto text-center promotion-tab"
      to="/promotion"
    >
      <IconPromotion class="w-4 h-4 pointer-events-none" />
      <div
        class="footer-menu-item-title promotion-tab pointer-events-none"
        :class="[
          $route.name === 'Promotion'
            ? 'text-[color:var(--selected)]'
            : 'fc-text4',
          isMain ? 'h-[14px] flex justify-center items-center' : '',
        ]"
      >
        {{ $t("promotion") }}
      </div>
    </nuxt-link>
    <nuxt-link
      :to="auth ? BET_HISTORY_ROUTES.INDEX : '/login'"
      class="text-center mx-auto flex-1"
    >
      <IconBetHistory class="w-4 h-4" />
      <div
        class="footer-menu-item-title"
        :class="[
          $route.matched[0].name === 'FeatureBetHistory'
            ? 'text-[color:var(--selected)]'
            : 'fc-text4',
          isMain ? 'h-[14px] flex justify-center items-center' : '',
        ]"
      >
        {{ $t("bet_history") }}
      </div>
    </nuxt-link>
    <nuxt-link
      v-if="auth && isShowDepositWithdrawal && isCashPlayer"
      class="text-center mx-auto flex-1"
      to="/deposit"
    >
      <IconDeposit class="w-4 h-4" />
      <div
        class="footer-menu-item-title"
        :class="[
          $route.matched[0].name === 'FeatureDeposit'
            ? 'text-[color:var(--selected)]'
            : 'fc-text4',
          isMain ? 'h-[14px] flex justify-center items-center' : '',
        ]"
      >
        {{ $t(`deposit${isBhinbhin}`) }}
      </div>
    </nuxt-link>
    <nuxt-link to="/contact-us" class="flex-1 mx-auto text-center">
      <IconContact class="w-4 h-4" />
      <div
        class="footer-menu-item-title"
        :class="[
          $route.matched[0].name === 'contact-us'
            ? 'text-[color:var(--selected)]'
            : 'fc-text4',
          isMain ? 'h-[14px] flex justify-center items-center' : '',
        ]"
      >
        {{ $t("contact") }}
      </div>
    </nuxt-link>
    <nuxt-link to="/profile" class="flex-1 mx-auto text-center relative">
      <div class="flex justify-center icon">
        <IconUser class="w-4 h-4" />
        <MessagesMessageCount
          :count="unreadInfo.TotalCount"
          :is-unread="true"
          class="!ml-0 absolute top-[6px] right-[10px]"
        ></MessagesMessageCount>
      </div>
      <div
        class="footer-menu-item-title"
        :class="[
          $route.matched[0].name === 'profile'
            ? 'text-[color:var(--selected)]'
            : 'fc-text4',
          isMain ? 'h-[14px] flex justify-center items-center' : '',
        ]"
      >
        {{ $t("account") }}
      </div>
    </nuxt-link>
  </div>
  <div
    v-if="!auth && displayAuthButtons"
    class="fixed bottom-0 left-0 z-30 w-full flex justify-center items-center fc-text bg-background2 shadow-top h-14"
  >
    <div
      class="flex items-center justify-center flex-1 h-full mx-auto text-center bg-secondary"
      @click="toggleLoginRegisterDialog()"
    >
      <div class="text-sm font-bold leading-4 fc-textBtn">
        {{ $t("capital_login") }}
      </div>
    </div>
    <div
      v-if="!register.IsHidden"
      :id="ID.SIGNUP"
      to="/register"
      class="flex items-center justify-center flex-1 h-full mx-auto text-center bg-green-400 bg-primary"
      @click="toggleLoginRegisterDialog(false)"
    >
      <div class="text-sm font-bold leading-4 fc-textBtn pointer-events-none">
        {{ $t("joinnow") }}
      </div>
    </div>
    <nuxt-link
      v-if="getContactList.length"
      to="/contact-us"
      class="w-14 h-14 flex justify-center items-center bg-background5 gap-1"
    >
      <svg-icon
        svg-name="icon-contact-new"
        class="icon w-[18px] h-[18px]"
        style="fill: var(--text3)"
      />
    </nuxt-link>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, toRefs } from "vue";
import { store } from "@/store";
import commonHelper from "@/utils/commonHelper";
import useMenu from "@/composables/useMenu";
import { useHeaderComponent } from "@/composables/useTheme";
import IconHome from "@/assets/icons/home.svg?component";
import IconPromotion from "@/assets/icons/promotion.svg?component";
import IconBetHistory from "@/assets/icons/bet-history.svg?component";
import IconDeposit from "@/assets/icons/deposit.svg?component";
import IconContact from "@/assets/icons/contacts.svg?component";
import IconUser from "@/assets/icons/user.svg?component";

export default defineComponent({
  name: "MFooterFunction1",
  components: {
    IconHome,
    IconPromotion,
    IconBetHistory,
    IconDeposit,
    IconContact,
    IconUser,
  },
  props: {
    auth: {
      type: Boolean,
      default: false,
    },
    displayAuthButtons: {
      type: Boolean,
      default: true,
    },
  },
  setup(_) {
    const router = useRouter();
    const route = useRoute();
    const { name } = toRefs(route);
    const { getContactList } = useContactUs();
    const { themeColor } = themePropertyHelper;
    const isMain = computed(() =>
      store.state.companyThemePropertiesFromApi.ThemeProperties[0].ThemeName.toLowerCase().includes(
        "main"
      )
    );
    const isIndex = computed(
      () => name.value === "home" || name.value === "index"
    );
    const onNavigateToPage = (url: string) => {
      if (_.auth) {
        window.open(url, "_blank");
      } else {
        router.push("/login");
      }
    };
    const { getAssetImage, toggleLoginRegisterDialog, isBhinbhin } = commonHelper;
    const { isShowDepositWithdrawal, isCashPlayer } = useMenu();
    const { isAllowPromotionTab, register } = useHeaderComponent();
    const { fetchMessages, unreadInfo } = useMessage();

    onMounted(() => {
      if (!route.fullPath.includes("messages")) {
        fetchMessages();
      }
    });

    return {
      name,
      isIndex,
      onNavigateToPage,
      getAssetImage,
      isShowDepositWithdrawal,
      isCashPlayer,
      isAllowPromotionTab,
      register,
      themeColor,
      toggleLoginRegisterDialog,
      isMain,
      getContactList,
      unreadInfo,
      isBhinbhin,
    };
  },
});
</script>
<style lang="scss">
.footer-menu {
  padding: 7.33px 0px;
  align-items: center;
  a {
    width: calc(100% / 5);
  }
}
.footer-menu-item-title {
  font-family: Roboto;
  font-size: 12px;
  font-weight: 400;
  line-height: 14.06px;
  text-align: center;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
}
.shadow-top {
  box-shadow: 0px -4px 3px rgba(0, 0, 0, 0.25);
}
a.router-lint-active svg {
  fill: var(--selected);
}
</style>
<style lang="scss" scoped>
a:not(.router-lint-active) svg.text {
  fill: var(--text5);
}

svg.fill-active {
  color: var(--selected) !important;
}

.fill-active {
  fill: var(--selected) !important;
}
.main-footer {
  & > a {
    height: 100%;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    position: relative;
    color: var(--text3);
    svg {
      opacity: 0.5;
    }

    &.router-link-active {
      &,
      .footer-menu-item-title {
        color: var(--primary) !important;
      }

      svg {
        opacity: 1;
      }

      &::after {
        content: "";
        position: absolute;
        bottom: 10px !important;
        left: calc(50% - 8px) !important;
        width: 16px !important;
        height: 2px;
        border-radius: 2px;
        background: var(--primary);
      }
    }
  }
  .router-link-exact-active:has(.footer-menu-item-title) {
    position: relative;
    .footer-menu-item-title {
      color: var(--text3);
    }
  }
  .router-link-exact-active:has(.footer-menu-item-title)::after {
    content: "";
    width: 100%;
    height: 2px;
    background: var(--primary);
    position: absolute;
    bottom: -10px;
    left: 0;
  }
}
</style>
